//
//  MapEditor.m
//  Awars III
//
//  Created by Killery on 2012/12/06.
//  Copyright (c) 2012年 Killery. All rights reserved.
//

#import "MapEditor.h"

@implementation MapEditor
-(void)awakeFromNib{

    [TFcurrentChipIndex setStringValue:[NSString stringWithFormat:@"%d/%d", MapChipListIndex,MapChipMax]];
    
    [loadMapListTV setTarget:self];
    [loadMapListTV setDoubleAction:@selector(doubleClickLM:)];
    
    [saveMapListTV setTarget:self];
    [saveMapListTV setDoubleAction:@selector(doubleClickLM:)];
}

-(id)init{
    if (self) {
        time0  = [NSTimer
                 scheduledTimerWithTimeInterval:0.05f
                 target:self
                 selector:@selector(EventLoop0:)
                 userInfo:nil
                 repeats:YES
                 ];
        MapChipListIndex = 1;
        BuildChipListIndex = 1;
        UnitChipListIndex = 1;
        loadMapListMA = [NSMutableArray new];
        [self initLoadMapList];
        saveMapListMA = [NSMutableArray new];
        [self initSaveMapList];
    }
    return self;
}

-(void)EventLoop0:(NSTimer*)time{
    if(SLSx == 0) [TFcurrentChipIndex setStringValue:[NSString stringWithFormat:@"%d/%d", MapChipListIndex,MapChipMax]];
    if(SLSx == 1) [TFcurrentChipIndex setStringValue:[NSString stringWithFormat:@"%d/%d", BuildChipListIndex,BuildChipMax]];
    if(SLSx == 2) [TFcurrentChipIndex setStringValue:[NSString stringWithFormat:@"%d/%d", UnitChipListIndex,UnitChipMax]];

    if(DoubleClicked){DoubleClicked = false;
        windowPoint.x = [MapEditorWindow frame].origin.x;
        windowPoint.y = [MapEditorWindow frame].origin.y;
    if(SLSx == 0){
        [PMCL setFrameOrigin:windowPoint];
        [PMCL makeKeyAndOrderFront:nil];
    }
    if(SLSx == 1){
        [PBCL setFrameOrigin:windowPoint];
        [PBCL makeKeyAndOrderFront:nil];
    }
    if(SLSx == 2){
        [PUCL setFrameOrigin:windowPoint];
        [PUCL makeKeyAndOrderFront:nil];
    }
    }
}

-(void)doubleClickLM:(id)sender{
    
    MFselectedRow = (int)[loadMapListTV selectedRow];
    loadMapListSubmitFlag = true;
    [loadMapWindow close];
}

-(IBAction)backTitle:(id)sender{
    windowPoint.x = [MapEditorWindow frame].origin.x;
    windowPoint.y = [MapEditorWindow frame].origin.y;
    [TitleWindow setFrameOrigin:windowPoint];
    [TitleWindow makeKeyAndOrderFront:nil];
    [MapEditorWindow close];
}
-(void)previous:(id)sender{
    if(SLSx == 0){
        if(MapChipListIndex <= 1) MapChipListIndex = MapChipMax;
        else MapChipListIndex--;
    }
    if(SLSx == 1){
        if(BuildChipListIndex <= 1) BuildChipListIndex = BuildChipMax;
        else BuildChipListIndex--;
    }
    if(SLSx == 2){
        if(UnitChipListIndex <= 1) UnitChipListIndex = UnitChipMax;
        else UnitChipListIndex--;
    }
}
-(void)next:(id)sender{
    if(SLSx == 0){
    if(MapChipListIndex >= MapChipMax) MapChipListIndex = 1;
    else MapChipListIndex++;
    }
    if(SLSx == 1){
    if(BuildChipListIndex >= BuildChipMax) BuildChipListIndex = 1;
    else BuildChipListIndex++;
    }
    if(SLSx == 2){
    if(UnitChipListIndex >= UnitChipMax) UnitChipListIndex = 1;
    else UnitChipListIndex++;
    }

}

-(IBAction)mapSizeSubmit:(id)sender{
    
    chipHeight = [mapSizeHeight intValue];
    chipWidth = [mapSizeWidth intValue];
    
    if(chipHeight < 15) chipHeight = 15;
    if(chipWidth < 15) chipWidth = 15;
    
    mapSizeChangedFlag = true;
    initMapChipNumbFlag = true;
    [mapSizeWindow close];
}
-(IBAction)mapSizeCancel:(id)sender{
    [mapSizeWindow close];
}

-(IBAction)mapSize:(id)sender{
    
    postWidth = chipWidth;
    postHeight = chipHeight;
    [mapSizeHeight setIntValue:chipHeight];
    [mapSizeWidth setIntValue:chipWidth];
    
    windowPoint.x = [MapEditorWindow frame].origin.x + 50;
    windowPoint.y = [MapEditorWindow frame].origin.y + 100;
    [mapSizeWindow setFrameOrigin:windowPoint];
    
    [mapSizeWindow makeKeyAndOrderFront:nil];
}

-(void)initLoadMapList{

    NSString *directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    NSArray *Farray;
    NSString *filePath = @"Map";
    Farray = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:filePath error:nil];
    
    fileNumb = (int)[Farray count];
    for (int i = 1; i < fileNumb;i++) {
        MF[i].fileName = [[Farray objectAtIndex:i] retain];
    }
    
    [self willChangeValueForKey:@"loadMapListMA"];
    [loadMapListMA removeAllObjects];
    [self didChangeValueForKey:@"loadMapListMA"];
    
    for(int i = 1; i < fileNumb;i++){
        NSMutableDictionary* dict = [NSMutableDictionary new];
        
        [dict setValue:[NSString stringWithFormat:@"%@", MF[i].fileName] forKey:@"name"];
        [self willChangeValueForKey:@"loadMapListMA"];
        [loadMapListMA addObject:dict];
        [self didChangeValueForKey:@"loadMapListMA"];
    }

}

-(void)initSaveMapList{

    NSString *directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    NSArray *Farray;
    NSString *filePath = @"Map";
    Farray = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:filePath error:nil];
    
    fileNumb = (int)[Farray count];
    for (int i = 1; i < fileNumb;i++) {
        MF[i].fileName = [[Farray objectAtIndex:i] retain];
    }
    
    
    [self willChangeValueForKey:@"saveMapListMA"];
    [saveMapListMA removeAllObjects];
    [self didChangeValueForKey:@"saveMapListMA"];
    
    for(int i = 1; i < fileNumb;i++){
        NSMutableDictionary* dict = [NSMutableDictionary new];
        
        [dict setValue:[NSString stringWithFormat:@"%@", MF[i].fileName] forKey:@"name"];
        [self willChangeValueForKey:@"saveMapListMA"];
        [saveMapListMA addObject:dict];
        [self didChangeValueForKey:@"saveMapListMA"];
    }


}

-(IBAction)loadMap:(id)sender{
    [self initLoadMapList];
    [loadMapWindow makeKeyAndOrderFront:nil];
    loadMapChipFlag = true;
}

-(IBAction)loadMapSubmit:(id)sender{
    
    MFselectedRow = (int)[loadMapListTV selectedRow];
    loadMapListSubmitFlag = true;
    [loadMapWindow close];
}
-(IBAction)loadMapCancel:(id)sender{
    [loadMapWindow close];
}

-(IBAction)saveMap:(id)sender{
    
    [self initSaveMapList];
    [saveMapListAC setSelectionIndex:-1];
    [saveMapWindow makeKeyAndOrderFront:nil];
}

-(IBAction)saveMapSubmit:(id)sender{
    
    saveMapDataName = [[saveMapTF stringValue] retain];
    saveMapListSubmitFlag = true;
    saveMapChipFlag = true;
    [saveMapWindow close];
}
-(IBAction)saveMapCancel:(id)sender{
    [saveMapWindow close];
}

@end
