//
//  MapView.m
//  Awars III
//
//  Created by Killery on 2012/12/15.
//  Copyright (c) 2012年 Killery. All rights reserved.
//

#import "MapView.h"

@implementation MapView

- (id)initWithFrame:(NSRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        time0  = [NSTimer
                 scheduledTimerWithTimeInterval:0.05f
                 target:self
                 selector:@selector(EventLoop00:)
                 userInfo:nil
                 repeats:YES
                 ];
        chip = [[self LoadImage:@"マス.png"] retain];
        
        chip1A = [[self LoadImage:@"ccはた青.png"] retain];
        chip2A = [[self LoadImage:@"ccはた青2.png"] retain];
        chip3A = [[self LoadImage:@"ccはた赤.png"] retain];
        chip4A = [[self LoadImage:@"ccはた赤2.png"] retain];
        chip5A = [[self LoadImage:@"ccはた黄.png"] retain];
        chip6A = [[self LoadImage:@"ccはた黄2.png"] retain];
        
        chip1B = [[self LoadImage:@"cc旗青.png"] retain];
        chip2B = [[self LoadImage:@"cc旗青2.png"] retain];
        chip3B = [[self LoadImage:@"cc旗赤.png"] retain];
        chip4B = [[self LoadImage:@"cc旗赤2.png"] retain];
        chip5B = [[self LoadImage:@"cc旗黄.png"] retain];
        chip6B = [[self LoadImage:@"cc旗黄2.png"] retain];
        
        buildTeamImg[0] = chip1A;
        buildTeamImg[1] = chip2A;
        buildTeamImg[2] = chip3A;
        buildTeamImg[3] = chip4A;
        buildTeamImg[4] = chip5A;
        buildTeamImg[5] = chip6A;
        unitTeamImg[0] = chip1B;
        unitTeamImg[1] = chip2B;
        unitTeamImg[2] = chip3B;
        unitTeamImg[3] = chip4B;
        unitTeamImg[4] = chip5B;
        unitTeamImg[5] = chip6B;
        [self initMapChipFileDirectory];
        
        for (int i = 0; i <= chipHeight;i++)
            for (int j = 0;j<= chipWidth;j++)
                unitNum[i][j] = -1;
        
        
         NSRect seRect = NSMakeRect(0, 0, chipHeight*32, chipWidth*32);
         [self setFrame:seRect];
         
         
    }
    
    
    
    
    
    
    return self;
}
-(void)EventLoop00:(NSTimer*)time{
    
    if(saveMapChipFlag){saveMapChipFlag = false;
        [self saveMapChip];
    }
    if(mapSizeChangedFlag){mapSizeChangedFlag = false;
        
        NSRect seRect;
        seRect.size.height = chipHeight*32;
        seRect.size.width = chipWidth*32;
        
        [self setFrame:seRect];
    }
    if(initMapChipNumbFlag){initMapChipNumbFlag = false;
        
        for(int i = 0;i <= chipWidth;i++){
            for(int j = 0;j <= chipHeight;j++){
                if(postHeight < j) {
                    buildNum[i][j] = -1;
                    unitNum[i][j] = -1;
                }
                if(postWidth < i){
                    buildNum[i][j] = -1;
                    unitNum[i][j] = -1;
                }
            
            }
        }
    }
    if(loadMapListSubmitFlag){loadMapListSubmitFlag = false;
        chipNum[1][1] = 2;
        [self loadMapChip];
        NSRect seRect;
        seRect.size.height = chipHeight*32;
        seRect.size.width = chipWidth*32;
        [self setFrame:seRect];
    }
    
    
    
    [self setNeedsDisplay:YES];
}


-(BOOL)isFlipped{
    return YES;
}

-(NSImage*)LoadImage:(NSString*)name{
    NSImage *image = [NSImage imageNamed:name];
    if(image == nil) return nil;
    
    return image;
}
-(void)DrawImage:(NSImage*)image x:(float)x y:(float)y cx:(int)cx cy:(int)cy{
    NSRect frRect;
    frRect.size.height = image.size.height;
    frRect.size.width = image.size.width;
    
    frRect.origin.x = 0;
    frRect.origin.y = 0;
    
    NSRect drRect;
    drRect.origin.x = x;
    drRect.origin.y = y;
    drRect.size.height = 32;
    drRect.size.width = 32;
    
    [image drawInRect:drRect fromRect:frRect operation:NSCompositeSourceOver fraction:1.0f respectFlipped:YES hints:nil];
    
}

-(void)mouseDown:(NSEvent *)theEvent{
    drugPoint = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    
    posX = (int)drugPoint.x/32 + 1;
    posY = (int)drugPoint.y/32 + 1;
    
    
    if(CommandSelected){
        if(SLSx == 1 && SLCy == 0) buildNum[posX][posY] = -1;
        if(SLSx == 2 && SLCy == 0) unitNum[posX][posY] = -1;
        if(SLSx == 0 && SLCy == 0) {buildTeam[posX][posY] = 0; unitTeam[posX][posY] = 0;}
    }else{
        if(SLSx == 0 && SLCy == 1) buildTeam[posX][posY] = SLindex;
        else if(SLSx == 0 && SLCy == 2) unitTeam[posX][posY] = SLindex;
        else if(SLSx == 0) chipNum[posX][posY] = SLindex;
        if(SLSx == 1) buildNum[posX][posY] = SLindexB;
        if(SLSx == 2) unitNum[posX][posY] = SLindexU;
    
    
    }
    
}

-(void)mouseDragged:(NSEvent *)theEvent{
    drugPoint = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    
    posX = (int)drugPoint.x/32+1;
    posY = (int)drugPoint.y/32+1;

    if(CommandSelected){
        if(SLSx == 1 && SLCy == 0) buildNum[posX][posY] = -1;
        if(SLSx == 2 && SLCy == 0) unitNum[posX][posY] = -1;
        if(SLSx == 0 && SLCy == 0) {buildTeam[posX][posY] = -1; unitTeam[posX][posY] = -1;}

    }else{
        if(SLSx == 0 && SLCy == 1) buildTeam[posX][posY] = SLindex;
        else if(SLSx == 0 && SLCy == 2) unitTeam[posX][posY] = SLindex;
        else if(SLSx == 0) chipNum[posX][posY] = SLindex;
        if(SLSx == 1) buildNum[posX][posY] = SLindexB;
        if(SLSx == 2) unitNum[posX][posY] = SLindexU;
    
    }
}

- (void)drawRect:(NSRect)dirtyRect
{
    int bx, by;
    for(bx=1;bx<=chipWidth;bx++){
        for(by=1;by<=chipHeight;by++){
            [self DrawImage:chip x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by];
            [self DrawImage:MC[chipNum[bx][by]].img x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by];
            if(buildNum[bx][by] >= 0) [self DrawImage:BC[buildNum[bx][by]].img x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by];
            if(unitNum[bx][by] >= 0) [self DrawImage:UC[unitNum[bx][by]].img x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by];
            
            if(buildTeam[bx][by] >= 0) [self DrawImage:buildTeamImg[buildTeam[bx][by]] x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by];
            if(unitTeam[bx][by] >= 0) [self DrawImage:unitTeamImg[unitTeam[bx][by]] x:(bx-1)*32 y:(by-1)*32 cx:bx cy:by];
            
            
        }
    
    }
}

-(void)initMapChipFileDirectory{
    NSString *directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];

    NSData *InitialData = [NSData dataWithContentsOfFile:@"Map/preset.txt"];
    
    NSString *path = @"Map";
    NSString *pathDATA = @"Map/MD00.txt";
    NSString *fileData = nil;
    if(!InitialData){
        
        [[NSFileManager defaultManager] createDirectoryAtPath:path withIntermediateDirectories:YES attributes:nil error:nil];
        [[NSFileManager defaultManager] createFileAtPath:pathDATA contents:nil attributes:nil];
        

        NSString *data2 =
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"####\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00\n"
        @"####\n"
        @"0,0,0"
        @"####\n"
        @"0,0,0"
        @"####\n"
        @"0,0,0"
        ;

        
        
        fileData = [NSString stringWithFormat:@"%@", data2];
        
        [fileData writeToFile:pathDATA atomically:YES encoding:NSUTF8StringEncoding error:nil];
    }

    fileData = [NSString stringWithContentsOfFile:pathDATA encoding:NSUTF8StringEncoding error:nil];
    fileDataArray = [fileData componentsSeparatedByString:@"\n"];

    int chipType = 0;
    int chipIndexDelta = 0;
    for(int i=1;i <= [fileDataArray count];i++){
        NSArray *items = [[fileDataArray objectAtIndex:i-1] componentsSeparatedByString:@","];
        
        NSRange rangeSearch = [[items objectAtIndex:0] rangeOfString:@"####"];
        
        if(rangeSearch.location != NSNotFound){
            chipType++;
            continue;
        }
        
        for(int j=1;j <= [items count];j++){
            unitTeam[i][j] = -1;
            buildTeam[i][j] = -1;
        }
        
        if(chipType == 0){chipIndexDelta++;
            for(int j=1;j <= [items count];j++){
                chipNum[j][i] = [[items objectAtIndex:j-1] intValue];
                chipWidth = (int)[items count];
                chipHeight = chipIndexDelta;
            }
        }else if(chipType == 1){
            for(int j=1;j <= [items count];j++){
                buildNum[j][i - chipIndexDelta-1] = [[items objectAtIndex:j-1] intValue]-1;
            }
        }else if(chipType == 2){
            for(int j=1;j <= [items count];j++){
                unitNum[[[items objectAtIndex:2] intValue]][[[items objectAtIndex:1] intValue]] = [[items objectAtIndex:0] intValue]-1;
            }
        }else if(chipType == 3){
            for(int j=1;j <= [items count];j++){
                buildTeam[[[items objectAtIndex:2] intValue]][[[items objectAtIndex:1] intValue]] = [[items objectAtIndex:0] intValue];
            }
        }else if(chipType == 4){
            for(int j=1;j <= [items count];j++){
                unitTeam[[[items objectAtIndex:2] intValue]][[[items objectAtIndex:1] intValue]] = [[items objectAtIndex:0] intValue];
            }
        }
    }
    
    
    mapSizeChangedFlag = true;
}

-(void)loadMapChip{
    NSString *directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    NSString *fileData = @"";
    NSString *pathDATA = @"Map/";
    
    for(int i = 0;i<=1000;i++){
        for(int j = 0;j<= 1000;j++){
            chipNum[i][j] = 0;
            buildNum[i][j] = -1;
            unitNum[i][j] = -1;
            buildTeam[i][j] = -1;
            unitTeam[i][j] = -1;
        }
    }
    
    pathDATA = [pathDATA stringByAppendingFormat:@"%@", MF[MFselectedRow+1].fileName];
    
    
    NSLog(@"%@", pathDATA);
    
    fileData = [NSString stringWithContentsOfFile:pathDATA encoding:NSUTF8StringEncoding error:nil];
    fileDataArray = [fileData componentsSeparatedByString:@"\n"];
    
    
    if(!fileData){
        mapChipDataLoadFail = true;
        return;
    }
    
    int chipType = 0;
    int chipIndexDelta = 0;
    int chipIndexDelta2 = 0;
    for(int i=1;i <= [fileDataArray count];i++){
        if([fileDataArray objectAtIndex:0] == NULL) break;
        NSArray *items = [[fileDataArray objectAtIndex:i-1] componentsSeparatedByString:@","];
        
        NSRange rangeSearch = [[items objectAtIndex:0] rangeOfString:@"####"];
        
        if(rangeSearch.location != NSNotFound){
            chipType++;
            continue;
        }
        
        if(chipType == 0){chipIndexDelta++;
            for(int j=1;j <= [items count];j++){
                chipNum[j][i] = [[items objectAtIndex:j-1] intValue];
                chipWidth = (int)[items count];
                chipHeight = chipIndexDelta;
            }
        }else if(chipType == 1){chipIndexDelta2++;
            for(int j=1;j <= [items count];j++){
                buildNum[j][i - chipIndexDelta-1] = [[items objectAtIndex:j-1] intValue]-1;
            }
        }else if(chipType == 2){
            for(int j=1;j <= [items count];j++){
                unitNum[[[items objectAtIndex:1] intValue]][[[items objectAtIndex:2] intValue]] = [[items objectAtIndex:0] intValue]-1;
            }
        }else if(chipType == 3){
            for(int j=1;j <= [items count] && [items count] >= 2;j++){
                buildTeam[[[items objectAtIndex:1] intValue]][[[items objectAtIndex:2] intValue]] = [[items objectAtIndex:0] intValue];
            }
        }else if(chipType == 4){
            for(int j=1;j <= [items count] && [items count] >= 2;j++){
                unitTeam[[[items objectAtIndex:1] intValue]][[[items objectAtIndex:2] intValue]] = [[items objectAtIndex:0] intValue];
            }
        }
    }
    
    mapSizeChangedFlag = true;
}

-(void)saveMapChip{
    NSString *directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];


    NSString *fileData = @"";
    NSString *pathDATA = @"Map/";

    for(int i = 1;i<= chipHeight;i++){
        for(int j = 1;j <= chipWidth;j++){
            fileData = [fileData stringByAppendingFormat:@"%2d", chipNum[j][i]];
            if(j == chipWidth) fileData = [fileData stringByAppendingFormat:@"\n"];
            else {
                fileData = [fileData stringByAppendingFormat:@","];
            }
        }
    }
    fileData = [fileData stringByAppendingFormat:@"####\n"];
    for(int i = 1;i<= chipHeight;i++){
        for(int j = 1;j <= chipWidth;j++){
            fileData = [fileData stringByAppendingFormat:@"%2d", buildNum[j][i]+1];
            if(j == chipWidth) fileData = [fileData stringByAppendingFormat:@"\n"];
            else {
                fileData = [fileData stringByAppendingFormat:@","];
            }
        }
    }
    fileData = [fileData stringByAppendingFormat:@"####\n"];
    for(int i = 1;i<= chipHeight;i++){
        for(int j = 1;j <= chipWidth;j++){
            if(unitNum[j][i] != -1){
                fileData = [fileData stringByAppendingFormat:@"%d", unitNum[j][i]+1];
                fileData = [fileData stringByAppendingFormat:@","];
                fileData = [fileData stringByAppendingFormat:@"%d", j];
                fileData = [fileData stringByAppendingFormat:@","];
                fileData = [fileData stringByAppendingFormat:@"%d", i];
                fileData = [fileData stringByAppendingFormat:@"\n"];
            }
        }
    }
    fileData = [fileData stringByAppendingFormat:@"####\n"];
    for(int i = 1;i<= chipHeight;i++){
        for(int j = 1;j <= chipWidth;j++){
            if(buildTeam[j][i] != -1){
                fileData = [fileData stringByAppendingFormat:@"%d", buildTeam[j][i]];
                fileData = [fileData stringByAppendingFormat:@","];
                fileData = [fileData stringByAppendingFormat:@"%d", j];
                fileData = [fileData stringByAppendingFormat:@","];
                fileData = [fileData stringByAppendingFormat:@"%d", i];
                fileData = [fileData stringByAppendingFormat:@"\n"];
            }
        }
    }
    fileData = [fileData stringByAppendingFormat:@"####\n"];
    for(int i = 1;i<= chipHeight;i++){
        for(int j = 1;j <= chipWidth;j++){
            if(unitTeam[j][i] != -1){
                fileData = [fileData stringByAppendingFormat:@"%d", unitTeam[j][i]];
                fileData = [fileData stringByAppendingFormat:@","];
                fileData = [fileData stringByAppendingFormat:@"%d", j];
                fileData = [fileData stringByAppendingFormat:@","];
                fileData = [fileData stringByAppendingFormat:@"%d", i];
                fileData = [fileData stringByAppendingFormat:@"\n"];
            }
        }
    }
    
    
    
    
    pathDATA = [pathDATA stringByAppendingFormat:@"%@", saveMapDataName];
    [[NSFileManager defaultManager] createFileAtPath:pathDATA contents:nil attributes:nil];
    [fileData writeToFile:pathDATA atomically:YES encoding:NSUTF8StringEncoding error:nil];

}


@end
